"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemActionControls = void 0;
const react_1 = __importStar(require("react"));
const tokens_1 = require("@leafygreen-ui/tokens");
const emotion_1 = require("@leafygreen-ui/emotion");
const item_action_menu_1 = require("./item-action-menu");
const constants_1 = require("./constants");
const item_action_group_1 = require("./item-action-group");
const actionControlsStyle = (0, emotion_1.css)({
    flex: 'none',
    marginLeft: 'auto',
    alignItems: 'center',
    display: 'flex',
});
// Action buttons are rendered 4px apart from each other. With this we keep the
// same spacing also when action buttons are rendered alongside action menu
// (happens when collapseAfter prop is specified)
const actionMenuWithActionControlsStyles = (0, emotion_1.css)({
    marginLeft: tokens_1.spacing[100],
});
function ItemActionControls({ isVisible = true, actions, onAction, className, menuClassName, iconClassName, iconStyle, iconSize = constants_1.ItemActionButtonSize.Default, renderMode, collapseAfter = 0, collapseToMenuThreshold = 2, 'data-testid': dataTestId, }) {
    const sharedProps = (0, react_1.useMemo)(() => ({
        isVisible,
        onAction,
        className: (0, emotion_1.cx)('item-action-controls', className),
        iconClassName,
        iconStyle,
        iconSize,
        'data-testid': dataTestId,
    }), [
        isVisible,
        onAction,
        className,
        iconClassName,
        iconStyle,
        iconSize,
        dataTestId,
    ]);
    const sharedMenuProps = (0, react_1.useMemo)(() => ({
        menuClassName,
        renderMode,
    }), [menuClassName, renderMode]);
    if (actions.length === 0) {
        return null;
    }
    // When user wants to show a few actions and collapse the rest into a menu
    if (collapseAfter > 0) {
        const visibleActions = actions.slice(0, collapseAfter);
        const collapsedActions = actions.slice(collapseAfter);
        return (react_1.default.createElement("div", { className: actionControlsStyle },
            react_1.default.createElement(item_action_group_1.ItemActionGroup, { actions: visibleActions, ...sharedProps }),
            react_1.default.createElement(item_action_menu_1.ItemActionMenu, { actions: collapsedActions, ...sharedProps, ...sharedMenuProps, className: (0, emotion_1.cx)(actionMenuWithActionControlsStyles, sharedProps.className) })));
    }
    const shouldShowMenu = actions.length >= collapseToMenuThreshold;
    if (shouldShowMenu) {
        return (react_1.default.createElement(item_action_menu_1.ItemActionMenu, { actions: actions, ...sharedProps, ...sharedMenuProps }));
    }
    return react_1.default.createElement(item_action_group_1.ItemActionGroup, { actions: actions, ...sharedProps });
}
exports.ItemActionControls = ItemActionControls;
//# sourceMappingURL=item-action-controls.js.map