"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemActionGroup = void 0;
const react_1 = __importStar(require("react"));
const emotion_1 = require("@leafygreen-ui/emotion");
const tokens_1 = require("@leafygreen-ui/tokens");
const leafygreen_1 = require("../leafygreen");
const constants_1 = require("./constants");
const item_action_menu_1 = require("./item-action-menu");
const item_action_button_1 = require("./item-action-button");
const utils_1 = require("./utils");
const containerStyle = (0, emotion_1.css)({
    flex: 'none',
    marginLeft: 'auto',
    alignItems: 'center',
    display: 'flex',
});
// TODO: Move to a parent component - or a flex gap
const actionGroupButtonStyle = (0, emotion_1.css)({
    '&:not(:first-child)': {
        marginLeft: tokens_1.spacing[100],
    },
});
function ItemActionGroup({ actions, onAction, className, iconClassName, iconStyle, iconSize = constants_1.ItemActionButtonSize.Default, isVisible = true, 'data-testid': dataTestId, }) {
    const onClick = (0, react_1.useCallback)((evt) => {
        evt.stopPropagation();
        onAction(evt.currentTarget.dataset.action);
    }, [onAction]);
    const shouldRender = isVisible && actions.length > 0;
    if (!shouldRender) {
        return null;
    }
    return (react_1.default.createElement("div", { className: (0, emotion_1.cx)(containerStyle, className), "data-testid": dataTestId }, actions.map((menuItem, idx) => {
        if ((0, item_action_menu_1.isSeparatorMenuAction)(menuItem)) {
            return react_1.default.createElement(leafygreen_1.MenuSeparator, { key: `separator-${idx}` });
        }
        const { expandedAs: ItemComponent = item_action_button_1.ItemActionButton, tooltip, tooltipProps, ...itemProps } = menuItem;
        const item = (react_1.default.createElement(ItemComponent, { key: itemProps.action, ...itemProps, iconSize: iconSize, iconStyle: iconStyle, iconClassName: iconClassName, onClick: onClick, "data-testid": (0, utils_1.actionTestId)(dataTestId, itemProps.action) }));
        if (tooltip) {
            return (react_1.default.createElement(leafygreen_1.Tooltip, { key: itemProps.action, ...tooltipProps, trigger: react_1.default.createElement("div", { className: actionGroupButtonStyle, style: { display: 'inherit' } }, item) }, tooltip));
        }
        return item;
    })));
}
exports.ItemActionGroup = ItemActionGroup;
//# sourceMappingURL=item-action-group.js.map