"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SmallIconButton = void 0;
const react_1 = __importStar(require("react"));
const emotion_1 = require("@leafygreen-ui/emotion");
const tokens_1 = require("@leafygreen-ui/tokens");
const leafygreen_1 = require("../leafygreen");
const action_glyph_1 = require("./action-glyph");
const iconContainerStyle = (0, emotion_1.css)({
    display: 'block',
    flex: 'none',
    fontSize: 0,
    lineHeight: 0,
});
// Using important here because leafygreen / emotion applies styles in the order
// that doesn't allow our styles override theirs
const buttonSizeStyle = {
    default: undefined,
    small: (0, emotion_1.css)({
        flex: 'none',
        width: `${tokens_1.spacing[4]}px !important`,
        height: `${tokens_1.spacing[4]}px !important`,
    }),
    xsmall: (0, emotion_1.css)({
        flex: 'none',
        // aligns with other xsmall components
        width: `${20}px !important`,
        height: `${20}px !important`,
    }),
};
exports.SmallIconButton = (0, react_1.forwardRef)(function SmallIconButton({ glyph, size, label, onClick, children, title, className, ...rest }, ref) {
    return (react_1.default.createElement(leafygreen_1.IconButton
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-expect-error leafygreen confuses TS a lot here
    , { 
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-expect-error leafygreen confuses TS a lot here
        ref: ref, className: (0, emotion_1.cx)(buttonSizeStyle[size], className), "aria-label": label, title: title, onClick: onClick, ...rest },
        react_1.default.createElement("span", { role: "presentation", className: iconContainerStyle },
            react_1.default.createElement(action_glyph_1.ActionGlyph, { glyph: glyph, size: size })),
        children));
});
//# sourceMappingURL=small-icon-button.js.map